#include <Dialogs.h>
#include <Files.h>
#include <Fonts.h>
#include <Processes.h>
#include <Windows.h>
#include <TextEdit.h>
#include <TextUtils.h>
#include <Aliases.h>
#include "MoreOSA.h"

extern struct qd;

void main()
{
	StringHandle		str;
	AliasHandle			alias;
	long				i;
	AEDesc				params;
	FSSpec				file;
	ScriptObject		*script;
	ProcessInfoRec		info;
	ProcessSerialNumber	psn;
	OSErr				err;
	
	InitGraf ( &qd.thePort );
	InitFonts ();
	InitWindows ();
	InitMenus ();
	TEInit ();
	InitDialogs (NULL);		// use of ResumeProcs no longer approved by Apple
	InitCursor ();
	FlushEvents ( everyEvent, 0 );

	// get file of application
	psn.highLongOfPSN = 0;
	psn.lowLongOfPSN = kCurrentProcess;
	info.processInfoLength = sizeof(info);
	info.processName = nil;
	info.processAppSpec = &file;
	GetProcessInformation(&psn, &info);
	// get name of script file
	str = GetString(128);
	BlockMove(*str, &file.name, *str[0]+1);
	script = new ScriptObject;
	// run the script
	err = NewAlias(nil, &file, &alias);
	if (err != noErr)
		DebugStr("\pNewAlias");
	script->Load(alias);
	script->Run();
	// build parameters
	err = AECreateList(nil, 0, false, &params);
	if (err != noErr)
		DebugStr("\pAECreateList");
	else {
		i = 2;
		err = AEPutPtr(&params, 1, typeInteger, &i, sizeof(i));
		if (err != noErr)
			DebugStr("\pAEPutPtr integer");
		str = GetString(129);
		if (str == nil)
			DebugStr("\pnil string");
		HLock((Handle)str);
		err = AEPutPtr(&params, 2, typeChar, &(*str)[1], (*str)[0]);
		if (err != noErr)
			DebugStr("\pAEPutPtr string");
		TRY {
			if (script->HasHandler("foo"))
				script->CallSubroutine("foo", &params);
			if (script->HasHandler("bar"))
				script->CallSubroutine("bar", nil);
		}
		CATCH {
			err = GETERROR;
		}
		AEDisposeDesc(&params);
	}
	delete script;
}

