#pragma once
#include <vector>
#include <string>
#ifdef macintosh
#include <MacMemory.h>
#endif

const std::string kEmptyString;

std::string AsString(short);
std::string AsString(unsigned short);
std::string AsString(int);
std::string AsString(unsigned);
std::string AsString(long);
std::string AsString(unsigned long);
	// simple integer
std::string BytesAsString(unsigned long);
	// 1K, 2 MB, etc.
std::string HexAsString(unsigned long);
	// 8-digit, 0-filled, uppercase hex
std::string CharsAsString(unsigned long integer);
	// four character constant
std::string DateAsString(unsigned long integer);
	// four character constant
std::string TimeAsString(unsigned long integer);
	// four character constant

std::string AsString(double);
	// floating point

#ifdef macintosh

std::string AsString(Handle);
	// Put a whole handle into a string.
std::string ConvertToString(Handle);
	// Destroys handle.

#endif // macintosh

void Substitute(std::string&, const std::string& oldString, const std::string& newString);
std::vector<std::string> SplitString(const std::string&, const std::string& delim);
std::string JoinString(const std::vector<std::string>&, const std::string& delim);
bool StringToTime(const std::string&, LongDateRec& dateTime);
